<?php

namespace Drupal\invite_link\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\invite_link\Form\InviteLinkBlockForm;
use Drupal\Core\Form\FormBuilderInterface;

/**
 * Provides an 'InviteLinkBlock' block.
 *
 * @Block(
 *  id = "invite_link_block",
 *  admin_label = @Translation("Invite Link Block"),
 *  deriver = "Drupal\invite\Plugin\Derivative\InviteBlock"
 * )
 */
class InviteLinkBlock extends BlockBase {

  /**
   * The form builder.
   *
   * @var \Drupal\Core\Form\FormBuilderInterface
   */
  protected $formBuilder;

  /**
   * Constructs a new Invite Link Block object.
   *
   * @param \Drupal\Core\Form\FormBuilderInterface $form_builder
   *   The form builder.
   */
  public function __construct(FormBuilderInterface $form_builder) {
    parent::__construct($entity_type, $storage);
    $this->formBuilder = $form_builder;
  }

  /**
   * {@inheritdoc}
   */
  public static function createInstance(ContainerInterface $container) {
    return new static(
      $container->get('form_builder'),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    $block_id = $this->getDerivativeId();
    $build = [];
    $form = $this->formBuilder->getForm(new InviteLinkBlockForm(), $block_id);
    $build['form'] = $form;

    return $build;
  }

}
